from Models import Project, Architecture, Executable, Project
from Models import Workflow, WorkflowStatus
from Models import WorkflowEntry, EntryStatus, Payload
from Models import User
from Models import ApprovedRequest
from Models import Location
from Models import Directory, DirectoryEntry
from Models import GeneratorInfo
from Models import SpecInfo

def createDefaultArchitecture (name):
    architectureSelect = Architecture.select (Architecture.q.name == name)
    if not architectureSelect.count ():
        Architecture (name=name)    

def createDefaultLocation (name, localDBS, localDLS):
    locationSelect = Location.select (Location.q.name == name)
    if not locationSelect.count ():
        Location (name=name, localDBS=localDBS, localDLS=localDLS, user_group=0)

def createDefaultProject (name, architectureName):
    projectSelect = Project.select (Project.q.name == name)
    architectureSelect = Architecture.select (Architecture.q.name == architectureName)
    if architectureSelect.count ():
        architecture = architectureSelect[0]
    else:
        architecture = Architecture (name=architecture)
    if not projectSelect.count ():
        Project (name=name, architecture_id=architecture.id)


class ProdRequestCore (object):
    def __init__ (self):
        pass
    
    def createDBSchema (self):
        Architecture.createTable (ifNotExists=True)
        Executable.createTable (ifNotExists=True)
        Payload.createTable (ifNotExists=True)
        Project.createTable (ifNotExists=True)
        Workflow.createTable (ifNotExists=True)
        WorkflowEntry.createTable (ifNotExists=True)
        User.createTable (ifNotExists=True)
        ApprovedRequest.createTable (ifNotExists=True)
        Location.createTable (ifNotExists=True)
        Directory.createTable (ifNotExists=True)
        DirectoryEntry.createTable (ifNotExists=True)
        GeneratorInfo.createTable (ifNotExists=True)
        SpecInfo.createTable (ifNotExists=True)
        createDefaultArchitecture ("slc3_ia32_gcc323")
        createDefaultArchitecture ("slc4_ia32_gcc345")
        createDefaultArchitecture ("slc4_amd64_gcc345")
        createDefaultLocation ("Any",
            "http://cmsdbs.cern.ch/cms/prod/comp/DBS/CGIServer/prodquery?instance=MCGlobal/Writer",
            "prod-lfc-cms-central.cern.ch/grid/cms/DLS/LFC")
        createDefaultLocation ("LCG team 1", 
            "http://cmsdbs.cern.ch/cms/prod/comp/DBS/CGIServer/prodquery?instance=MCLocal_2/Writer",
            "prod-lfc-cms-central.cern.ch/grid/cms/DLS/MCLocal_2")
        createDefaultLocation ("LCG team 2", 
            "http://cmsdbs.cern.ch/cms/prod/comp/DBS/CGIServer/prodquery?instance=MCLocal_3/Writer",
            "prod-lfc-cms-central.cern.ch/grid/cms/DLS/MCLocal_3")
        createDefaultLocation ("LCG team 3", 
            "http://cmsdbs.cern.ch/cms/prod/comp/DBS/CGIServer/prodquery?instance=MCLocal_4/Writer",
            "prod-lfc-cms-central.cern.ch/grid/cms/DLS/MCLocal_4")
        createDefaultLocation ("LCG team 4", 
            "http://cmsdbs.cern.ch/cms/prod/comp/DBS/CGIServer/prodquery?instance=MCLocal_5/Writer",
            "prod-lfc-cms-central.cern.ch/grid/cms/DLS/MCLocal_5")
        createDefaultLocation ("LCG team 5", 
            "http://cmsdbs.cern.ch/cms/prod/comp/DBS/CGIServer/prodquery?instance=MCLocal_6/Writer",
            "prod-lfc-cms-central.cern.ch/grid/cms/DLS/MCLocal_6")
        createDefaultLocation ("LCG team 6", 
            "http://cmsdbs.cern.ch/cms/prod/comp/DBS/CGIServer/prodquery?instance=MCLocal_9/Writer",
            "prod-lfc-cms-central.cern.ch/grid/cms/DLS/MCLocal_9")
        createDefaultLocation ("OSG", 
            "http://cmsdbs.cern.ch/cms/prod/comp/DBS/CGIServer/prodquery?instance=MCLocal_1/Writer",
            "prod-lfc-cms-central.cern.ch/grid/cms/DLS/MCLocal_1")
        
        createDefaultProject ("CMSSW_1_2_3", "slc3_ia32_gcc323")
       
    def submitToProdManager (self, entry, consumer=None):
        ApprovedRequest (entry=entry, 
                         consumer=consumer or entry.preferred_consumer)
        return True
        
