from Framework import rpccall, xmlBooleanResponse, templatepage, templateXML
from Framework.Utilities import selectFromDict
from Framework import Controller
from Tools.SecurityModuleCore import Role, Group, is_authorized

from Models.WorkflowEntryModel import WorkflowEntry
from Models.PayloadModel import Payload
from MessageService.MessageService import MessageService
from DatasetInjector.DatasetInjectorDB import ownerIndex
from Models import EntryStatus, Workflow

from ProdCommon.MCPayloads.WorkflowMaker import WorkflowMaker
import ProdCommon.MCPayloads.WorkflowTools as WorkflowTools

from os.path import basename, abspath
import time
from time import strftime
from datetime import datetime
from Modules.Utilities.Language import safeString
import os
from Framework.PluginManager import DeclarePlugin 


class ProdRequestPA (Controller):
    def __init__ (self, context):
        Controller.__init__ (self, context, __file__)
        try:
            os.environ['PRODAGENT_CONFIG']
            self.messageService = MessageService ()
            self.messageService.registerAs ("ProdRequest")
            self.messageService.publish("DatasetInjector:StartDebug","none")
            self.messageService.publish("JobCreator:StartDebug","none")
            self.messageService.publish("JobSubmitter:StartDebug","none")
            self.messageService.publish("DBSInterface:StartDebug","none")
            self.messageService.publish("TrackingComponent:StartDebug","none")
            self.messageService.commit()
            self.messageService.publish("JobCreator:SetCreator","LCGCreator")
            self.messageService.publish("JobSubmitter:SetSubmitter","NoSubmit")
            self.messageService.commit()
            self.enabled = True
        except KeyError:
            print "Warning! ProdAgent not found!"
            print "Please make sure that PRODAGENT_CONFIG env variable is set."
    
    @xmlBooleanResponse
    def setEnabled (self, **args):
        if not args.has_key ("enabled"):
            return False
        if args["enabled"] == "true":
            self.enabled = True
            return True
        else:
            self.enabled = False
            return True
    
    @xmlBooleanResponse
    def submitRequest (self, **args):
        #TODO: rewrite so that it uses WorkflowEntry.workflow_spec
        pass
        #run = None
        #if args.has_key ("run"):
        #    run = str (args["run"])
        #sitePref = ""
        #if args.has_key ("site_pref"):
        #    site_pref = str (args["site_pref"])
        #
        #selectFromDict (args, "request_id", "nevents", "njobs")
        #requestSelect = Request.select (Request.q.id == args["request_id"])
        #ms = self.messageService
        #
        #for request in requestSelect:
        #    entrySelect = WorkflowEntry.select (WorkflowEntry.q.workflow_id == request.workflow_id)
        #    ## Set Creator
        #    for entry in entrySelect:
        #        payloadSelect = Payload.select (Payload.q.id == entry.payload_id)
        #        payload = None
        #        
        #        for p in payloadSelect:
        #            payload = p
        #        tmpFilename = payload.name + datetime.isoformat (datetime.now ()) + ".xml"
        #        tmpFilename = safeString (tmpFilename)
        #        print "Creating production workflow"
        #        primaryDatasetName = entry.primary_dataset
        #        if not primaryDatasetName:
        #            primaryDatasetName = "GenerationJob%s" % strftime("%Y-%m-%dT%H:%M:%S", datetime.now ().timetuple ())
        #        
        #        if not reqReleaseName:
        #            reqReleaseName = payload.version
        #        
        #        maker = WorkflowMaker (entry.id, entry.primary_dataset, "Spring07")
        #        maker.setCMSSWVersion (reqReleaseName)
        #        maker.setPhysicsGroup (IdToPhysicsGroup (entry.physics_group))
        #        maker.setConfiguration (payload, Format="python", Type="string")
        #        maker.setPSetHash (payload.pset_hash)
        #        
        #        if not entry.pileup_dataset in ("", "None", None, "pileup_dataset"):
        #            maker.addPileupDataset (entry.pileup_dataset)
        #        
        #        if not entry.input_dataset in ("", "None", None, "input_dataset"):
        #            maker.addInputDataset (entry.input_dataset)
        #            maker.inputDataset['SplitType'] = "event"
        #            maker.inputDataset['SplitSize'] = 500
        #        
        #        maker.addSelectionEfficiency (entry.selection_efficiency)
        #        
        #        workflowspec = maker.makeWorkflow ()
        #
        #        
        #        workflow = createProductionWorkflow (prodName=entry.primary_dataset,
        #                                             cmsswVersion=payload.version,
        #                                             cfgFile=None,
        #                                             category="mc",
        #                                             PyCfg=payload.parsed_parameterset,
        #                                             PSetHash=payload.pset_hash,
        #                                             FakeHash=True,
        #                                             physicsGroup=entry.physics_group,
        #                                             processingLabel="Spring07")
        #                                                
        #        if entry.pileup_dataset != "" and entry.pileup_dataset != "None" and entry.pileup_dataset != None:
        #            print "Pileup_dataset found %s" % entry.pileup_dataset
        #            puPrimary, puTier, puProcessed = entry.pileup_dataset.split ("/")
        #            puInfo = spec.payload.addPileupDataset( puPrimary, puTier, puProcessed)
        #            puInfo['FilesPerJob'] = 1
        #            puInfo['DBSAddress'] = "MCGlobal/Writer"
        #            puInfo['DBSURL'] = "http://cmsdbs.cern.ch/cms/prod/comp/DBS/CGIServer/prodquery"
        #            puInfo['DLSType'] = "DLS_TYPE_LFC"
        #            puInfo['DLSAddress'] = "prod-lfc-cms-central.cern.ch/grid/cms/DLS/LFC"
        #            
        #        
        #        workflow.save (tmpFilename)
        #        
        #        
        #        if run != None: 
        #            # if run number is provided set the workflow and its initial run
        #            ms.publish ("RequestInjector:SetWorkflow", abspath (tmpFilename))
        #            ms.commit ()
        #            time.sleep (0.1)
        #            ms.publish ("RequestInjector:SetInitialRun", run)
        #            ms.commit ()
        #            ms.publish ("RequestInjector:SelectWorkflow", basename (tmpFilename))
        #            ms.commit ()
        #        else:
        #            # if no run number is provided, reload the Workflow and start run from there
        #            ms.publish ("RequestInjector:LoadWorkflows", '')
        #            ms.commit ()
        #            time.sleep (0.1)
        #            workflowBase=basename (tmpFilename)
        #            ms.publish ("RequestInjector:SelectWorkflow", workflowBase)
        #            ms.commit ()
        #        ms.publish("RequestInjector:SetEventsPerJob", args["nevents"])
        #        ms.commit()
        #        time.sleep(2)
        #        
        #        # TODO: this is in the case of an initial production... 
        #        # It should be the dataset name (???) in the case of a 
        #        ms.publish("RequestInjector:NewDataset", basename (tmpFilename))
        #        ms.commit()
        #        #TODO: Use DatasetInjector in the case of productions with an input
        #        # datasets, rather than a primary dataset.
        #        print "Number of jobs %s" % args["njobs"]
        #        for i in range (1, int (args["njobs"])):
        #            ms.publish("RequestInjector:ResourcesAvailable", "none")
        #            ms.commit()
        #    request.status_id = EntryStatus.LOCALSUBMIT
    
    @xmlBooleanResponse
    @is_authorized (Role("JOB_MANAGER"), Group ("ProdRequest"))
    def setConfiguration (self, **kw):
        if kw["job_submitter"]:
            self.messageService.publish("JobSubmitter:SetSubmitter",kw["job_submitter"])
        
DeclarePlugin ("/Controllers/ProdRequest/ProdAgentInteraction", ProdRequestPA, {"baseUrl": "/ProdRequestPA"})
