from Models.WorkflowEntryModel import IdToEntryStatus, IdToPhysicsGroup
from ProdRequestCommon.PersistencyTools import serializable_property

class RequestProxy (object):
    def __init__ (self, entry, user, locations):
        self.entry = entry
        self.__user = user
        self.__locations = locations
    name = serializable_property (lambda self: self.entry.name)
    user = serializable_property (lambda self: self.__user)
    id = serializable_property (lambda self: self.entry.id)
    events = serializable_property (lambda self: self.entry.requested_events)
    status = serializable_property (lambda self: self.entry.status)
    primary_dataset = serializable_property (lambda self: self.entry.primary_dataset)
    priority = serializable_property (lambda self: self.entry.priority_hint)
    selection_efficiency = serializable_property (lambda self: self.entry.selection_efficiency)
    entryId = serializable_property (lambda self : self.entry.id)
    status_string = serializable_property (lambda self: IdToEntryStatus (self.entry.status))
    physics_group = serializable_property (lambda self: IdToPhysicsGroup (self.entry.physics_group))
    cmssw_version = serializable_property (lambda self: self.entry.project and self.entry.project.name or "")
    comment = serializable_property (lambda self: self.entry.workflow and self.entry.workflow.comment or "")
    locationHints = serializable_property (lambda self : [location
                                                          for location in self.__locations.get (self.entry.id, [])])
