from ProdRequestCommon.DataBase import DataBase
import os
from os.path import exists

dbName = "prodrequest.db"
dbOpt = {}

try:
    import ConfigParser, os
    config = ConfigParser.ConfigParser ()
    configurationFilename = os.getenv ("PRODREQUEST_CONFIG")
    if not exists (str (configurationFilename)):
        configurationFilename = "prodrequest.cfg"
    config.read (configurationFilename)
    dbInstance = config.get ("prodrequest", "dbInstance")
    dbOpt["type"] = config.get (dbInstance, "type")
    dbName = config.get (dbInstance, "name")
    if dbOpt["type"] != "sqlite":
        dbOpt["host"] = config.get (dbInstance, "host")
        dbOpt["port"] = config.get (dbInstance, "port")
        dbOpt["username"] = config.get (dbInstance, "username")
        dbOpt["passwd"] = config.get (dbInstance, "password")
except Exception, e:
    print "Using default db connection."
    print e

prodRequestDb = DataBase (dbName, **dbOpt)
prodRequestDb.connect ()

from Models.ArchitectureModel import Architecture
from Models.ExecutableModel import Executable
from Models.PayloadModel import Payload
from Models.ProjectModel import Project
from Models.WorkflowEntryModel import WorkflowEntry, EntryStatus, EntryPriorityHint, PhysicsGroup, IdToPhysicsGroup, IdToEntryStatus, ConsumerName
from Models.WorkflowModel import Workflow, WorkflowStatus
from Models.User import User
from Models.ApprovedRequest import ApprovedRequest
from Models.Location import Location
from Models.Directory import Directory
from Models.DirectoryEntry import DirectoryEntry
from Models.CfgFile import CfgFile
from Models.GeneratorInfo import GeneratorInfo
from Models.SpecInfo import SpecInfo